## texlive-bin 2025.20250727.75242+ds

=== Makefile ===
# Extension used in the name of library files
LIB_EXT= .so # for Linux and most *nixes
#LIB_EXT= .dylib # for MacOS X

# Compiler option to generate shared object or dynamic library
LIB_OPTION= -shared # for Linux and most *nixes
#LIB_OPTION= -dynamiclib #for MacOS X

# Installation directories
INSTALL_LIB_DIR= /usr/local/lib
INSTALL_LUA_DIR= /usr/local/lua

# Compilation directives
WARN= -O2 -Wall -fPIC -W -Waggregate-return -Wcast-align -Wmissing-prototypes -Wnested-externs -Wshadow -Wwrite-strings
INCS= -I/usr/local/include/lua5
CFLAGS= $(WARN) $(INCS)
LIBS= -L/usr/local/lib -llua -llualib -lm -ldl -lzzip
CC= gcc

##########################################################################
LIBNAME= liblzip$(LIB_EXT)

SRCS= lzip.c
OBJS= lzip.o

$(LIBNAME): $(OBJS)
	$(CC) $(CFLAGS) $(LIB_OPTION) -o $(LIBNAME) $(OBJS) $(LIBS)

install: $(LIBNAME)
	cp $(LIBNAME) $(INSTALL_LIB_DIR)
	cp zip.lua $(INSTALL_LUA_DIR)

clean:
	rm -f $(LIBNAME) $(OBJS)

=== libs/lua53/lua53-src/Makefile ===
# Makefile for installing Lua
# See doc/readme.html for installation and customization instructions.

# == CHANGE THE SETTINGS BELOW TO SUIT YOUR ENVIRONMENT =======================

# Your platform. See PLATS for possible values.
PLAT= none

# Where to install. The installation starts in the src and doc directories,
# so take care if INSTALL_TOP is not an absolute path. See the local target.
# You may want to make INSTALL_LMOD and INSTALL_CMOD consistent with
# LUA_ROOT, LUA_LDIR, and LUA_CDIR in luaconf.h.
INSTALL_TOP= /usr/local
INSTALL_BIN= $(INSTALL_TOP)/bin
INSTALL_INC= $(INSTALL_TOP)/include
INSTALL_LIB= $(INSTALL_TOP)/lib
INSTALL_MAN= $(INSTALL_TOP)/man/man1
INSTALL_LMOD= $(INSTALL_TOP)/share/lua/$V
INSTALL_CMOD= $(INSTALL_TOP)/lib/lua/$V

# How to install. If your install program does not support "-p", then
# you may have to run ranlib on the installed liblua.a.
INSTALL= install -p
INSTALL_EXEC= $(INSTALL) -m 0755
INSTALL_DATA= $(INSTALL) -m 0644
#
# If you don't have "install" you can use "cp" instead.
# INSTALL= cp -p
# INSTALL_EXEC= $(INSTALL)
# INSTALL_DATA= $(INSTALL)

# Other utilities.
MKDIR= mkdir -p
RM= rm -f

# == END OF USER SETTINGS -- NO NEED TO CHANGE ANYTHING BELOW THIS LINE =======

# Convenience platforms targets.
PLATS= aix bsd c89 freebsd generic linux macosx mingw posix solaris

# What to install.
TO_BIN= lua luac
TO_INC= lua.h luaconf.h lualib.h lauxlib.h lua.hpp
TO_LIB= liblua.a
TO_MAN= lua.1 luac.1

# Lua version and release.
V= 5.3
R= $V.6

# Targets start here.
all:	$(PLAT)

$(PLATS) clean:
	cd src && $(MAKE) $@

test:	dummy
	src/lua -v

install: dummy
	cd src && $(MKDIR) $(INSTALL_BIN) $(INSTALL_INC) $(INSTALL_LIB) $(INSTALL_MAN) $(INSTALL_LMOD) $(INSTALL_CMOD)
	cd src && $(INSTALL_EXEC) $(TO_BIN) $(INSTALL_BIN)
	cd src && $(INSTALL_DATA) $(TO_INC) $(INSTALL_INC)
	cd src && $(INSTALL_DATA) $(TO_LIB) $(INSTALL_LIB)
	cd doc && $(INSTALL_DATA) $(TO_MAN) $(INSTALL_MAN)

uninstall:
	cd src && cd $(INSTALL_BIN) && $(RM) $(TO_BIN)
	cd src && cd $(INSTALL_INC) && $(RM) $(TO_INC)
	cd src && cd $(INSTALL_LIB) && $(RM) $(TO_LIB)
	cd doc && cd $(INSTALL_MAN) && $(RM) $(TO_MAN)

local:
	$(MAKE) install INSTALL_TOP=../install

none:
	@echo "Please do 'make PLATFORM' where PLATFORM is one of these:"
	@echo "   $(PLATS)"
	@echo "See doc/readme.html for complete instructions."

# make may get confused with test/ and install/
dummy:

# echo config parameters
echo:
	@cd src && $(MAKE) -s echo
	@echo "PLAT= $(PLAT)"
	@echo "V= $V"
	@echo "R= $R"
	@echo "TO_BIN= $(TO_BIN)"
	@echo "TO_INC= $(TO_INC)"
	@echo "TO_LIB= $(TO_LIB)"
	@echo "TO_MAN= $(TO_MAN)"
	@echo "INSTALL_TOP= $(INSTALL_TOP)"
	@echo "INSTALL_BIN= $(INSTALL_BIN)"
	@echo "INSTALL_INC= $(INSTALL_INC)"
	@echo "INSTALL_LIB= $(INSTALL_LIB)"
	@echo "INSTALL_MAN= $(INSTALL_MAN)"
	@echo "INSTALL_LMOD= $(INSTALL_LMOD)"
	@echo "INSTALL_CMOD= $(INSTALL_CMOD)"
	@echo "INSTALL_EXEC= $(INSTALL_EXEC)"
	@echo "INSTALL_DATA= $(INSTALL_DATA)"

# echo pkg-config data
pc:
	@echo "version=$R"
	@echo "prefix=$(INSTALL_TOP)"
	@echo "libdir=$(INSTALL_LIB)"
	@echo "includedir=$(INSTALL_INC)"

# list targets that do not create files (but not all makes understand .PHONY)
.PHONY: all $(PLATS) clean test install local none dummy echo pecho lecho

# (end of Makefile)

=== libs/luajit/LuaJIT-src/Makefile ===
##############################################################################
# LuaJIT top level Makefile for installation. Requires GNU Make.
#
# Please read doc/install.html before changing any variables!
#
# Suitable for POSIX platforms (Linux, *BSD, OSX etc.).
# Note: src/Makefile has many more configurable options.
#
# ##### This Makefile is NOT useful for Windows! #####
# For MSVC, please follow the instructions given in src/msvcbuild.bat.
# For MinGW and Cygwin, cd to src and run make with the Makefile there.
#
# Copyright (C) 2005-2025 Mike Pall. See Copyright Notice in luajit.h
##############################################################################

MAJVER=  2
MINVER=  1
ABIVER=  5.1

# LuaJIT uses rolling releases. The release version is based on the time of
# the latest git commit. The 'git' command must be available during the build.
RELVER= $(shell cat src/luajit_relver.txt 2>/dev/null || : )
# Note: setting it with := doesn't work, since it will change during the build.

MMVERSION= $(MAJVER).$(MINVER)
VERSION= $(MMVERSION).$(RELVER)

##############################################################################
#
# Change the installation path as needed. This automatically adjusts
# the paths in src/luaconf.h, too. Note: PREFIX must be an absolute path!
#
export PREFIX= /usr/local
export MULTILIB= lib
##############################################################################

DPREFIX= $(DESTDIR)$(PREFIX)
INSTALL_BIN=   $(DPREFIX)/bin
INSTALL_LIB=   $(DPREFIX)/$(MULTILIB)
INSTALL_SHARE_= $(PREFIX)/share
INSTALL_SHARE= $(DESTDIR)$(INSTALL_SHARE_)
INSTALL_DEFINC= $(DPREFIX)/include/luajit-$(MMVERSION)
INSTALL_INC=   $(INSTALL_DEFINC)

export INSTALL_LJLIBD= $(INSTALL_SHARE_)/luajit-$(MMVERSION)
INSTALL_JITLIB= $(DESTDIR)$(INSTALL_LJLIBD)/jit
INSTALL_LMODD= $(INSTALL_SHARE)/lua
INSTALL_LMOD= $(INSTALL_LMODD)/$(ABIVER)
INSTALL_CMODD= $(INSTALL_LIB)/lua
INSTALL_CMOD= $(INSTALL_CMODD)/$(ABIVER)
INSTALL_MAN= $(INSTALL_SHARE)/man/man1
INSTALL_PKGCONFIG= $(INSTALL_LIB)/pkgconfig

INSTALL_TNAME= luajit-$(VERSION)
INSTALL_TSYMNAME= luajit
INSTALL_ANAME= libluajit-$(ABIVER).a
INSTALL_SOSHORT1= libluajit-$(ABIVER).so
INSTALL_SOSHORT2= libluajit-$(ABIVER).so.$(MAJVER)
INSTALL_SONAME= libluajit-$(ABIVER).so.$(VERSION)
INSTALL_DYLIBSHORT1= libluajit-$(ABIVER).dylib
INSTALL_DYLIBSHORT2= libluajit-$(ABIVER).$(MAJVER).dylib
INSTALL_DYLIBNAME= libluajit-$(ABIVER).$(VERSION).dylib
INSTALL_PCNAME= luajit.pc

INSTALL_STATIC= $(INSTALL_LIB)/$(INSTALL_ANAME)
INSTALL_DYN= $(INSTALL_LIB)/$(INSTALL_SONAME)
INSTALL_SHORT1= $(INSTALL_LIB)/$(INSTALL_SOSHORT1)
INSTALL_SHORT2= $(INSTALL_LIB)/$(INSTALL_SOSHORT2)
INSTALL_T= $(INSTALL_BIN)/$(INSTALL_TNAME)
INSTALL_TSYM= $(INSTALL_BIN)/$(INSTALL_TSYMNAME)
INSTALL_PC= $(INSTALL_PKGCONFIG)/$(INSTALL_PCNAME)

INSTALL_DIRS= $(INSTALL_BIN) $(INSTALL_LIB) $(INSTALL_INC) $(INSTALL_MAN) \
  $(INSTALL_PKGCONFIG) $(INSTALL_JITLIB) $(INSTALL_LMOD) $(INSTALL_CMOD)
UNINSTALL_DIRS= $(INSTALL_JITLIB) $(DESTDIR)$(INSTALL_LJLIBD) $(INSTALL_INC) \
  $(INSTALL_LMOD) $(INSTALL_LMODD) $(INSTALL_CMOD) $(INSTALL_CMODD)

RM= rm -f
MKDIR= mkdir -p
RMDIR= rmdir 2>/dev/null
SYMLINK= ln -sf
INSTALL_X= install -m 0755
INSTALL_F= install -m 0644
UNINSTALL= $(RM)
LDCONFIG= ldconfig -n 2>/dev/null
SED_PC= sed -e "s|^prefix=.*|prefix=$(PREFIX)|" \
	    -e "s|^multilib=.*|multilib=$(MULTILIB)|" \
	    -e "s|^relver=.*|relver=$(RELVER)|"
ifneq ($(INSTALL_DEFINC),$(INSTALL_INC))
  SED_PC+= -e "s|^includedir=.*|includedir=$(INSTALL_INC)|"
endif

FILE_T= luajit
FILE_A= libluajit.a
FILE_SO= libluajit.so
FILE_MAN= luajit.1
FILE_PC= luajit.pc
FILES_INC= lua.h lualib.h lauxlib.h luaconf.h lua.hpp luajit.h
FILES_JITLIB= bc.lua bcsave.lua dump.lua p.lua v.lua zone.lua \
	      dis_x86.lua dis_x64.lua dis_arm.lua dis_arm64.lua \
	      dis_arm64be.lua dis_ppc.lua dis_mips.lua dis_mipsel.lua \
	      dis_mips64.lua dis_mips64el.lua \
	      dis_mips64r6.lua dis_mips64r6el.lua \
	      vmdef.lua

ifeq (,$(findstring Windows,$(OS)))
  HOST_SYS:= $(shell uname -s)
else
  HOST_SYS= Windows
endif
TARGET_SYS?= $(HOST_SYS)

ifeq (Darwin,$(TARGET_SYS))
  INSTALL_SONAME= $(INSTALL_DYLIBNAME)
  INSTALL_SOSHORT1= $(INSTALL_DYLIBSHORT1)
  INSTALL_SOSHORT2= $(INSTALL_DYLIBSHORT2)
  LDCONFIG= :
  SED_PC+= -e "s| -Wl,-E||"
endif

##############################################################################

INSTALL_DEP= src/luajit

default all $(INSTALL_DEP):
	@echo "==== Building LuaJIT $(MMVERSION) ===="
	$(MAKE) -C src
	@echo "==== Successfully built LuaJIT $(MMVERSION) ===="

install: $(INSTALL_DEP)
	@echo "==== Installing LuaJIT $(VERSION) to $(PREFIX) ===="
	$(MKDIR) $(INSTALL_DIRS)
	cd src && $(INSTALL_X) $(FILE_T) $(INSTALL_T)
	cd src && test -f $(FILE_A) && $(INSTALL_F) $(FILE_A) $(INSTALL_STATIC) || :
	$(RM) $(INSTALL_DYN) $(INSTALL_SHORT1) $(INSTALL_SHORT2)
	cd src && test -f $(FILE_SO) && \
	  $(INSTALL_X) $(FILE_SO) $(INSTALL_DYN) && \
	  ( $(LDCONFIG) $(INSTALL_LIB) || : ) && \
	  $(SYMLINK) $(INSTALL_SONAME) $(INSTALL_SHORT1) && \
	  $(SYMLINK) $(INSTALL_SONAME) $(INSTALL_SHORT2) || :
	cd etc && $(INSTALL_F) $(FILE_MAN) $(INSTALL_MAN)
	cd etc && $(SED_PC) $(FILE_PC) > $(FILE_PC).tmp && \
	  $(INSTALL_F) $(FILE_PC).tmp $(INSTALL_PC) && \
	  $(RM) $(FILE_PC).tmp
	cd src && $(INSTALL_F) $(FILES_INC) $(INSTALL_INC)
	cd src/jit && $(INSTALL_F) $(FILES_JITLIB) $(INSTALL_JITLIB)
	$(SYMLINK) $(INSTALL_TNAME) $(INSTALL_TSYM)
	@echo "==== Successfully installed LuaJIT $(VERSION) to $(PREFIX) ===="

uninstall:
	@echo "==== Uninstalling LuaJIT $(VERSION) from $(PREFIX) ===="
	$(UNINSTALL) $(INSTALL_TSYM) $(INSTALL_T) $(INSTALL_STATIC) $(INSTALL_DYN) $(INSTALL_SHORT1) $(INSTALL_SHORT2) $(INSTALL_MAN)/$(FILE_MAN) $(INSTALL_PC)
	for file in $(FILES_JITLIB); do \
	  $(UNINSTALL) $(INSTALL_JITLIB)/$$file; \
	  done
	for file in $(FILES_INC); do \
	  $(UNINSTALL) $(INSTALL_INC)/$$file; \
	  done
	$(LDCONFIG) $(INSTALL_LIB)
	$(RMDIR) $(UNINSTALL_DIRS) || :
	@echo "==== Successfully uninstalled LuaJIT $(VERSION) from $(PREFIX) ===="

##############################################################################

amalg:
	@echo "==== Building LuaJIT $(MMVERSION) (amalgamation) ===="
	$(MAKE) -C src amalg
	@echo "==== Successfully built LuaJIT $(MMVERSION) (amalgamation) ===="

clean:
	$(MAKE) -C src clean

.PHONY: all install amalg clean

##############################################################################

=== texk/detex/detex-src/Makefile ===
# Copyright (c) 1986-2007 Purdue University
# All rights reserved.
#
# Developed by:  Daniel Trinkle
#                Department of Computer Science, Purdue University
#                http://www.cs.purdue.edu/
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal with the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# o Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimers.
#
# o Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimers in the
#   documentation and/or other materials provided with the distribution.
#
# o Neither the names of Daniel Trinkle, Purdue University, nor the
#   names of its contributors may be used to endorse or promote products
#   derived from this Software without specific prior written
#   permission.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
# ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
# CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
#
#
#	Makefile for detex and delatex
#
# Detex is a program to remove TeX and LaTeX constructs from text source.

UNAME_S := $(shell uname -s)

# Installation directory
#
DESTDIR	= /usr/local/bin

# Specify you favorite compiler
#
#CC	= gcc

# Compile time flags, just uncomment the necessary lines
# Some say GNU make does not correctly handle += -- you may have to use :=
#
DEFS	=
#
# Add -traditional for GNU cc on ISC 386/ix system and possibly others
# (reported by pinard@iro.umontreal.ca)
#
#DEFS	+= ${DEFS} -traditional
#
# Add -DHAVE_STRING_H for the SysV string manipulation routines
#
#DEFS	+= ${DEFS} -DHAVE_STRING_H
#
# Add -DMAXPATHLEN=<length> if it is not defined in /usr/include/sys/param.h
#
#DEFS	+= ${DEFS} -DMAXPATHLEN=1024
#
# Add -DNO_MALLOC_DECL if your system does not like the malloc() declaration
# in detex.l (reported by pinard@iro.umontreal.ca)
#
#DEFS	+= ${DEFS} -DNO_MALLOC_DECL
#
CFLAGS	+= -O -DVERSION=\"${VERSION}\" ${DEFS} -Wall

# Use your favorite lexical scanner
#
#LEX	= lex
LEX	= flex

#LFLAGS	= -8 -C

# scanner library
#
LEXLIB	= -lfl
ifeq ($(UNAME_S),Darwin)
	LEXLIB	= -ll
endif

LPR	= lpr -p

# Program names
#
PROGS	= detex delatex

# Header files
#
HDR	= detex.h

# Sources
#
SRC	= detex.l

# Objects for various programs
#
D_OBJ	= detex.o

VERSION = 2.8.11

all:	${PROGS}

detex: ${D_OBJ}
	${CC} ${CFLAGS} -o $@ ${D_OBJ} ${LEXLIB}

delatex: detex
	cp detex delatex

detex.c: detex.l
	${LEX} ${LFLAGS} detex.l
	mv lex.yy.c detex.c

man-page:
	troff -man detex.1

# If you want detex available as delatex, uncomment the last two lines of
# this target
install: all
	rm -f ${DESTDIR}/detex
	install -c -m 775 -g staff -s detex ${DESTDIR}
	install detex.1 /usr/local/share/man/man1
#	rm -f ${DESTDIR}/delatex
#	ln ${DESTDIR}/detex ${DESTDIR}/delatex

uninstall:
	rm -f ${DESTDIR}/detex
	rm -f ${DESTDIR}/delatex
	rm -f /usr/local/share/man/man1/detex.*

clean:
	-rm -f a.out core *.s *.o ERRS errs .,* .emacs_[0-9]*
	-rm -f ${PROGS} xxx.l lex.yy.c detex.c
	-rm -f *.tar.bz2

print:	${HDR} ${SRC}
	${LPR} Makefile ${HDR} ${SRC}

test: all
	./test.pl

run: delatex
	./delatex in > out.txt

package: clean detex.c
	tar cjfv opendetex-${VERSION}.tar.bz2 --exclude='*.o' ChangeLog COPYRIGHT detex.* INSTALL Makefile README

# Dependencies
#
detex.c: detex.h
detex.c: detex.l

inpdf:
	cd test && xelatex -interaction=nonstopmode in.tex || echo there were errors
	rm -f test/*.toc test/*.log test/*.aux
	mv test/in.pdf .

=== texk/dvipsk/vms/Makefile ===
#
#   Makefile for dvips.  Edit this first part of the file.
#
#   This version is for Vax/VMS running the Todd Aven MAKE program.
#
#   First, the things that absolutely must be edited for your system.
#   Please, don't forget to edit MakeTeXPK in the same way!

# where TeX is `rooted'.  Sometimes /usr/local/lib/tex.
# TEXDIR = /usr/lib/tex
TEXDIR = /usr/lib/tex

# another place pk, tfm, and vf files might be found.
# LOCALDIR = /LocalLibrary/Fonts/TeXFonts
LOCALDIR = /LocalLibrary/Fonts/TeXFonts

# the default path to search for TFM files 
# (this usually is identical to TeX's defaultfontpath, which omits `.')
# (private fonts are given an explicit directory, which overrides the path)
#   overridden by the environment variable TEXFONTS
# TFMPATH = $(LOCALDIR)/tfm:$(TEXDIR)/fonts/tfm
TFMPATH = ""TEX_FONTS:""	# TEX_FONTS is a searchlist.

# the default path to search for PK files (usually omits `.')
# Don't forget to add the directory that
# MakeTeXPK puts the files!  (In this case, /LocalLibrary/Fonts...)
#   overridden by the environment variable TEXPKS or TEXPACKED or PKFONTS
# PKPATH = $(LOCALDIR)/pk:$(TEXDIR)/fonts/pk
PKPATH = ""VC$3:[PHS595F.FONTS.%d]%f.PK,TEX_DISK:[TEX.FONTS.%d]%f.PK,""

# the default path to search for VF files (usually omits `.')
#   overridden by the environment variable VFFONTS
# VFPATH = $(LOCALDIR)/vf:$(TEXDIR)/fonts/vf
VFPATH = ""TEX_VF:""		# TEX_VF may be a searchlist.

# additional directories in which to search for subdirectories to find
# both tfm and pk files
FONTSUBDIRPATH = """"

# where the config files go
# CONFIGDIR = $(TEXDIR)/ps
CONFIGDIR = TEX$POSTSCRIPT:		# The Physics Dept. DVIPS directory

# the default path to search for config files
#   overridden by the environment variable TEXCONFIG
# CONFIGPATH = .:$(CONFIGDIR)
CONFIGPATH = "" ,SYS$LOGIN:,$(CONFIGDIR),""

# the name of your config file
# CONFIGFILE = config.ps
CONFIGFILE = config.ps

# where the header PS files go
# HEADERDIR = $(TEXDIR)/ps
HEADERDIR = TEX$POSTSCRIPT:		# The Physics Dept. DVIPS directory

# the default path to search for header files
# HEADERPATH = .:$(HEADERDIR)
HEADERPATH = "" ,SYS$LOGIN:,$(HEADERDIR),""

# where epsf.tex and rotate.tex go (usually the TeX macros directory)
# TEXMACRODIR = $(TEXDIR)/inputs
TEXMACRODIR = TEX_INPUTS:

# the default path to search for epsf and psfiles
# (usually the same as TeX's defaultinputpath)
# FIGPATH = .:..:$(TEXDIR)/inputs
FIGPATH = "" ,TEX_INPUTS:,""  # Include blank so it looks on default dir.

# the place man pages are located.
# MANDIR = /usr/man/man1
MANDIR = TEX_INPUTS:

# change -DDEFRES=300 or whatever is required
#    if the default resolution is not 300 dpi,
# add -DDEBUG to turn on debugging capability
# add -DTPIC for tpic support
# add -DFONTLIB to search font libraries
# add -DSEARCH_SUBDIRECTORIES to search the FONTSUBDIRPATH.
# add -DHAVE_GETCWD if you have getcwd (relevant only for subdir searching)
# add -DIBM6000 for compiling on IBM 6000 systems
# add -DCREATIONDATE if your system has a working time() and you want dated files
# (for VM/CMS, see the MKDVIPS.EXEC file in the vmcms subdirectory).
#
#   If you define FONTLIB, make sure to also give definitions to
#   FLIPATH and FLINAME.
#
# DEFS= -DTPIC -DDEBUG -DDEFRES=400
DEFS= TPIC,DEBUG,DEFRES=300,HAVE_GETCWD,ANSI,CREATIONDATE

# either use
# OPT = -g -Wall -funsigned-char
# or
# OPT = -O -s -Wall -funsigned-char
OPT = 

# libraries to include (-lm -lc on most systems)
#FLIBS= -lNeXT_s -lsys_s
FLIBS=,sys$disk:[.vms]vaxcrtl/opt
# LIBS= 				# VAXC
LIBS= ,gnu_cc:[000000]GCCLIB/LIB	# GNUC

# If you are compiling dvips for suid or other privileges, you will
# definitely want to define the following symbol; else don't.
# SECURE = -DSECURE
SECURE =

# If you want EMTEX specials, define the following.
EMTEX =,EMTEX

# for SYSV (and friends which use <string.h> instead of <strings.h>)
# define the c-compiler flag
# add -D_POSIX_SOURCE if you are POSIX (also define SYSV) (only relevant
# for subdir searching)
# SYS = -DSYSV
SYS =

# Define this to be whatever you use for installation.  If you don't have
# install, use a script that invokes copy and chmod's the files
# appropriately.
# INSTALL = install
INSTALL = copy

# where the installed binary goes
# BINDIR = /usr/bin
BINDIR = TEX$POSTSCRIPT:	# The Physics Dept. DVIPS directory

# Define the default paper format (Actually no longer used)
DEFPFMT =

# PATHS =\					# VAXC
#  ,TFMPATH="$(TFMPATH)",\
#  PKPATH="$(PKPATH)",\
#  VFPATH="$(VFPATH)",\
#  HEADERPATH="$(HEADERPATH)",\
#  CONFIGPATH="$(CONFIGPATH)",\
#  CONFIGFILE="""$(CONFIGFILE)""",\
#  FONTSUBDIRPATH="$(FONTSUBDIRPATH)",\
#  FIGPATH="$(FIGPATH)"
PATHS =						# GNUC

INC = /include="SYS$DISK:[],SYS$SHARE:"
# CC      = CC					# VAXC
CC      = GCC/NoCase_Hack			# GNUC
CFLAGS  = /NoList $(INC)-
 /Define=($(DEFS) $(OPT) $(SYS) $(SECURE) $(EMTEX) $(DEFPFMT))
CFLAGS2 = /NoList $(INC)-
 /Define=($(DEFS) $(OPT) $(SYS) $(SECURE) $(EMTEX) $(DEFPFMT) $(PATHS))
LFLAGS  = /NoMap

SRC = dospecial.c dviinput.c fontdef.c loadfont.c dvips.c tfmload.c \
	download.c prescan.c scanpage.c skippage.c output.c scalewidth.c \
	dosection.c dopage.c resident.c search.c unpack.c drawPS.c \
	header.c makefont.c repack.c virtualfont.c dpicheck.c finclude.c \
	pprescan.c papersiz.c flib.c color.c bbox.c emspecial.c

OBJ = dospecial.obj, dviinput.obj, fontdef.obj, loadfont.obj, dvips.obj,\
	tfmload.obj, download.obj, prescan.obj, scanpage.obj, skippage.obj,\
	output.obj, scalewidth.obj, dosection.obj, dopage.obj, resident.obj,\
	search.obj, unpack.obj, drawPS.obj, header.obj, makefont.obj,\
	repack.obj, virtualfont.obj, dpicheck.obj, finclude.obj, \
	pprescan.obj, papersiz.obj, flib.obj, color.obj, bbox.obj, \
	emspecial.obj, vaxvms.obj

all : afm2tfm.exe dvips.exe tex.pro texps.pro texc.pro special.pro \
	finclude.pro color.pro crop.pro dvips.hlb

dvips.exe : $(OBJ)
	Link /Exe=DviPS.exe $(LFLAGS) $(OBJ) $(LIBS) $(FLIBS)

# dvips.obj : dvips.c vmscli.c			# VAXC
dvips.obj : dvips.c vmscli.c vms_gcc_paths.h	# GNUC
	$(CC) $(CFLAGS2) dvips.c

afm2tfm.exe : afm2tfm.obj
	Link $(LFLAGS) afm2tfm.obj $(LIBS) $(FLIBS)

afm2tfm.obj : afm2tfm.c
	$(CC) $(CFLAGS) afm2tfm.c

$(OBJ) : dvips.h debug.h vms.h

flib.obj resident.obj dvips.obj loadfont.obj tfmload.obj : paths.h

vaxvms.obj : [.vms]vaxvms.c
! 	$(CC) $(CFLAGS) [.vms]vaxvms.c /object=[]vaxvms.obj

vmscli.c : [.vms]vmscli.c
	Copy /Log [.vms]vmscli.c []

vms.h : [.vms]vms.h
	Copy /Log [.vms]vms.h []

vms_gcc_paths.h : [.vms]vms_gcc_paths.h		# GNUC
	Copy /Log [.vms]vms_gcc_paths.h []	# GNUC

*.obj : *.c
	$(CC) $(CFLAGS) $<

squeeze.exe : squeeze.obj
	Link $(LFLAGS) squeeze.obj $(LIBS) $(FLIBS)

squeeze.obj : squeeze.c
	$(CC) $(CFLAGS) squeeze.c

tex.pro : tex.lpro squeeze.exe
	MCR sys$disk:[]squeeze tex.lpro tex.pro

texc.pro: texc.lpro squeeze.exe
	MCR sys$disk:[]squeeze texc.lpro texc.pro

texc.lpro: tex.lpro
	@[.vms]texc_scr.com # tex.lpro texc.lpro

texps.pro : texps.lpro squeeze.exe
	MCR sys$disk:[]squeeze texps.lpro texps.pro

special.pro : special.lpro squeeze.exe
	MCR sys$disk:[]squeeze special.lpro special.pro

finclude.pro : finclude.lpro squeeze.exe
	MCR sys$disk:[]squeeze finclude.lpro finclude.pro

color.pro : color.lpro squeeze.exe
	MCR sys$disk:[]squeeze color.lpro color.pro

crop.pro : crop.lpro squeeze.exe
	MCR sys$disk:[]squeeze crop.lpro crop.pro

dvips.hlb : dvips.hlp
	Library/Create=Blocks:40/Help dvips.hlb dvips.hlp

dvips.hlp : [.vms]dvips.rnh
	Runoff [.vms]dvips.rnh

install : afm2tfm.exe dvips.exe dvips.hlb [.vms]MakeTeXPK.com \
	tex.pro texc.pro texps.pro special.pro finclude.pro color.pro \
	crop.pro config.ps psfonts.map epsf.tex epsf.sty rotate.tex \
	rotate.sty colordvi.tex colordvi.sty blackdvi.tex blackdvi.sty
# 	- mkdir $(BINDIR)
# 	- mkdir $(HEADERDIR)
# 	- mkdir $(CONFIGDIR)
# 	- mkdir $(MANDIR)
# 	- mkdir $(TEXMACRODIR)
	$(INSTALL) afm2tfm.exe $(BINDIR)afm2tfm.exe
	$(INSTALL) dvips.exe $(BINDIR)dvips.exe
	$(INSTALL) dvips.hlb $(BINDIR)dvips.hlb
#	$(INSTALL) [.VMS]MakeTeXPK.COM $(BINDIR)MakeTeXPK.COM
	$(INSTALL) tex.pro $(HEADERDIR)
	$(INSTALL) texc.pro $(HEADERDIR)
	$(INSTALL) texps.pro $(HEADERDIR)
	$(INSTALL) special.pro $(HEADERDIR)
	$(INSTALL) finclude.pro $(HEADERDIR)
	$(INSTALL) color.pro $(HEADERDIR)
	$(INSTALL) crop.pro $(HEADERDIR)
	$(INSTALL) config.ps $(CONFIGDIR)$(CONFIGFILE)
	$(INSTALL) psfonts.map $(CONFIGDIR)
	$(INSTALL) epsf.tex $(TEXMACRODIR)
	$(INSTALL) epsf.sty $(TEXMACRODIR)
	$(INSTALL) rotate.tex $(TEXMACRODIR)
	$(INSTALL) rotate.sty $(TEXMACRODIR)
	$(INSTALL) colordvi.sty $(TEXMACRODIR)
	$(INSTALL) colordvi.tex $(TEXMACRODIR)
	$(INSTALL) blackdvi.sty $(TEXMACRODIR)
	$(INSTALL) blackdvi.tex $(TEXMACRODIR)
	$(INSTALL) dvips.tex $(TEXMACRODIR)
	$(INSTALL) dvipsmac.tex $(TEXMACRODIR)
	$(INSTALL) dvips.1 $(MANDIR)
	$(INSTALL) afm2tfm.1 $(MANDIR)

veryclean :
	Delete *.obj;*, dvips.exe;*, squeeze.exe;*, afm2tfm.exe;*,\
	texc.lpro;*, *.pro;*, *.log;*, *.dvi;*

clean :
	Delete *.obj;*, squeeze.exe;*, afm2tfm.exe;*, *.log;*, *.dvi;*

# lint :
# 	lint $(DEFS) $(PATHS) $(SRC)
# 	lint $(DEFS) squeeze.c
# 	lint $(DEFS) afm2tfm.c

=== texk/web2c/cwebdir/Makefile ===
# This file is part of CWEB.
# It is distributed WITHOUT ANY WARRANTY, express or implied.
# Version 4.12.1 --- January 2025

# Copyright (C) 1987,1990,1993,2000 Silvio Levy and Donald E. Knuth

# Permission is granted to make and distribute verbatim copies of this
# document provided that the copyright notice and this permission notice
# are preserved on all copies.

# Permission is granted to copy and distribute modified versions of this
# document under the conditions for verbatim copying, provided that the
# entire resulting derived work is given a different name and distributed
# under the terms of a permission notice identical to this one.

#
# Read the README file, then edit this file to reflect local conditions
#

# directory for TeX inputs (cwebmac.tex goes here)
MACROSDIR= /usr/share/texmf/tex/generic

# directory for CWEB inputs in @i files
CWEBINPUTS= /usr/local/lib/cweb

# extension for manual pages ("l" distinguishes local from system stuff)
MANEXT= l
#MANEXT= 1

# directory for manual pages (cweb.1 goes here)
MANDIR= /usr/share/man/man$(MANEXT)

# destination directory for executables; must end in /
DESTDIR= /usr/local/bin/

# directory for GNU EMACS Lisp code (cweb.el goes here)
EMACSDIR= /usr/share/emacs/site-lisp

# Set DESTPREF to null if you want to call the executables "tangle" and "weave"
# (probably NOT a good idea; we recommend leaving DESTPREF=c)
DESTPREF=c

# Set CCHANGES to comm-foo.ch if you need changes to common.w
CCHANGES=

# Set TCHANGES to ctang-foo.ch if you need changes to ctangle.w
TCHANGES=

# Set WCHANGES to cweav-foo.ch if you need changes to cweave.w
WCHANGES=

# We keep debugging info around, for fun, but most users don't need it
CFLAGS = -g # -Wall -Wextra -Wimplicit-fallthrough=2 # check compiler warnings
#CFLAGS = -O
LINKFLAGS = -g
#LINKFLAGS = -s # for smaller (stripped) executables on many UNIX systems

# What C compiler are you using?
CC = cc

# RM and CP are used below in case rm and cp are aliased
RM= /bin/rm
CP= /bin/cp

# uncomment the second line if you use pdftex to bypass .dvi files
# uncomment the third line if you use xetex to bypass .dvi files
# uncomment the forth line if you use hitex for HINT output
PDFTEX = dvipdfm
#PDFTEX = pdftex
#PDFTEX = xetex
#PDFTEX = hitex
#PDFTEX = luatex

##########  You shouldn't have to change anything after this point #######

CWEAVE = ./cweave
CTANGLE = ./ctangle
SOURCES = cweave.w common.w ctangle.w
ALL =  common.w ctangle.w cweave.w prod.w \
	Makefile README common.c common.h ctangle.c \
	cwebman.tex cwebacromac.tex cwebmac.tex \
	cweb.1 cweb.el c++lib.w iso_types.w \
	comm-man.ch ctang-man.ch cweav-man.ch \
	comm-bs.ch ctang-bs.ch cweav-bs.ch makefile.bs \
	comm-pc.ch ctang-pc.ch cweav-pc.ch comm-amiga.ch \
	comm-ql.ch ctang-ql.ch cweav-ql.ch readme.ql \
	comm-vms.ch ctang-vms.ch cweav-vms.ch \
	comm-w32.ch ctang-w32.ch cweav-w32.ch \
	comm-os2.ch comm-mac.ch

.SUFFIXES: .dvi .tex .w .pdf .hnt

.w.tex:
	$(CWEAVE) $*

.tex.dvi:	
	tex $<

.w.dvi:
	make $*.tex
	make $*.dvi

.w.c:
	$(CTANGLE) $*

.w.o:
	make $*.c
	make $*.o

.w.pdf:
	make $*.tex
	case "$(PDFTEX)" in \
	 dvipdfm ) tex "\let\pdf+ \input $*"; dvipdfm $* ;; \
	 pdftex ) pdftex $* ;; \
	 xetex ) xetex $* ;; \
	 luatex ) luatex $* ;; \
	esac

.w.hnt:
	make $*.tex
	case "$(PDFTEX)" in \
	 hitex ) hitex $* ;; \
	esac

all: ctangle cweave

cautiously: ctangle
	$(CP) common.c SAVEcommon.c
	./ctangle common $(CCHANGES)
	diff common.c SAVEcommon.c
	$(RM) SAVEcommon.c
	$(CP) ctangle.c SAVEctangle.c
	./ctangle ctangle $(TCHANGES)
	diff ctangle.c SAVEctangle.c
	$(RM) SAVEctangle.c

SAVEctangle.c:
	$(CP) ctangle.c SAVEctangle.c

SAVEcommon.c:
	$(CP) common.c SAVEcommon.c

common.c: common.w $(CCHANGES) common.h
	$(CTANGLE) common $(CCHANGES)

common.o: common.c
	$(CC) $(CFLAGS) -DCWEBINPUTS=\"$(CWEBINPUTS)\" -c common.c

ctangle: ctangle.o common.o
	$(CC) $(LINKFLAGS) -o ctangle ctangle.o common.o

ctangle.c: ctangle.w $(TCHANGES) common.h
	$(CTANGLE) ctangle $(TCHANGES)

cweave: cweave.o common.o
	$(CC) $(LINKFLAGS) -o cweave cweave.o common.o

cweave.c: cweave.w $(WCHANGES) common.h prod.w
	$(CTANGLE) cweave $(WCHANGES)

doc: $(SOURCES:.w=.dvi)

usermanual: cwebman.tex cwebmac.tex
	$(PDF)tex cwebman

fullmanual: usermanual $(SOURCES) comm-man.ch ctang-man.ch cweav-man.ch
	make cweave
	./cweave common.w comm-man.ch
	$(PDF)tex common.tex
	./cweave ctangle.w ctang-man.ch
	$(PDF)tex ctangle.tex
	./cweave cweave.w cweav-man.ch
	$(PDF)tex cweave.tex

# be sure to leave ctangle.c and common.c for bootstrapping
clean:
	$(RM) -f -r *~ *.o common.tex cweave.tex cweave.c ctangle.tex \
	  *.log *.dvi *.toc *.idx *.scn *.pdf *.hnt core cweave ctangle

install: all
	- mkdir $(DESTDIR)
	$(CP) cweave $(DESTDIR)$(DESTPREF)weave
	chmod 755 $(DESTDIR)$(DESTPREF)weave
	$(CP) ctangle $(DESTDIR)$(DESTPREF)tangle
	chmod 755 $(DESTDIR)$(DESTPREF)tangle
	- mkdir $(MANDIR)
	$(CP) cweb.1 $(MANDIR)/cweb.$(MANEXT)
	chmod 644 $(MANDIR)/cweb.$(MANEXT)
	- mkdir $(MACROSDIR)
	$(CP) cwebacromac.tex $(MACROSDIR)
	chmod 644 $(MACROSDIR)/cwebacromac.tex
	$(CP) cwebmac.tex $(MACROSDIR)
	chmod 644 $(MACROSDIR)/cwebmac.tex
	- mkdir $(EMACSDIR)
	$(CP) cweb.el $(EMACSDIR)
	chmod 644 $(EMACSDIR)/cweb.el
	- mkdir $(CWEBINPUTS)
	$(CP) c++lib.w $(CWEBINPUTS)
	chmod 644 $(CWEBINPUTS)/c++lib.w
	$(CP) iso_types.w $(CWEBINPUTS)
	chmod 644 $(CWEBINPUTS)/iso_types.w

floppy: $(ALL) examples
	bar cvhf /dev/rfd0 $(ALL) examples
	bar tvf /dev/rfd0
	eject

tags: $(ALL)
	etags -lnone $(ALL)

tarfile: $(ALL) examples
	tar cvhf /tmp/cweb.tar $(ALL) examples
	gzip -9 /tmp/cweb.tar

tarball:
	tar zcvhf /tmp/cweb.tgz $(ALL) examples

ctan:
	git archive -o ~/cweb-4.12.1.zip --prefix=cweb/ cweb-4.12.1
	make PDF=pdf usermanual
	cd ..; zip -r ~/cweb-4.12.1.zip cweb/cwebman.pdf

=== libs/luajit/LuaJIT-src/src/Makefile ===
##############################################################################
# LuaJIT Makefile. Requires GNU Make.
#
# Please read doc/install.html before changing any variables!
#
# Suitable for POSIX platforms (Linux, *BSD, OSX etc.).
# Also works with MinGW and Cygwin on Windows.
# Please check msvcbuild.bat for building with MSVC on Windows.
#
# Copyright (C) 2005-2025 Mike Pall. See Copyright Notice in luajit.h
##############################################################################

MAJVER=  2
MINVER=  1
ABIVER=  5.1
NODOTABIVER= 51

##############################################################################
#############################  COMPILER OPTIONS  #############################
##############################################################################
# These options mainly affect the speed of the JIT compiler itself, not the
# speed of the JIT-compiled code. Turn any of the optional settings on by
# removing the '#' in front of them. Make sure you force a full recompile
# with "make clean", followed by "make" if you change any options.
#
DEFAULT_CC = gcc
#
# LuaJIT builds as a native 32 or 64 bit binary by default.
CC= $(DEFAULT_CC)
#
# Use this if you want to force a 32 bit build on a 64 bit multilib OS.
#CC= $(DEFAULT_CC) -m32
#
# Since the assembler part does NOT maintain a frame pointer, it's pointless
# to slow down the C part by not omitting it. Debugging, tracebacks and
# unwinding are not affected -- the assembler part has frame unwind
# information and GCC emits it where needed (x64) or with -g (see CCDEBUG).
CCOPT= -O2 -fomit-frame-pointer
# Use this if you want to generate a smaller binary (but it's slower):
#CCOPT= -Os -fomit-frame-pointer
# Note: it's no longer recommended to use -O3 with GCC 4.x.
# The I-Cache bloat usually outweighs the benefits from aggressive inlining.
#
# Target-specific compiler options:
#
# x86/x64 only: For GCC 4.2 or higher and if you don't intend to distribute
# the binaries to a different machine you could also use: -march=native
#
CCOPT_x86= -march=i686 -msse -msse2 -mfpmath=sse
CCOPT_x64=
CCOPT_arm=
CCOPT_arm64=
CCOPT_ppc=
CCOPT_mips=
#
CCDEBUG=
# Uncomment the next line to generate debug information:
#CCDEBUG= -g
#
CCWARN= -Wall
# Uncomment the next line to enable more warnings:
#CCWARN+= -Wextra -Wdeclaration-after-statement -Wredundant-decls -Wshadow -Wpointer-arith
#
##############################################################################

##############################################################################
################################  BUILD MODE  ################################
##############################################################################
# The default build mode is mixed mode on POSIX. On Windows this is the same
# as dynamic mode.
#
# Mixed mode creates a static + dynamic library and a statically linked luajit.
BUILDMODE= mixed
#
# Static mode creates a static library and a statically linked luajit.
#BUILDMODE= static
#
# Dynamic mode creates a dynamic library and a dynamically linked luajit.
# Note: this executable will only run when the library is installed!
#BUILDMODE= dynamic
#
##############################################################################

##############################################################################
#################################  FEATURES  #################################
##############################################################################
# Enable/disable these features as needed, but make sure you force a full
# recompile with "make clean", followed by "make".
XCFLAGS=
#
# Permanently disable the FFI extension to reduce the size of the LuaJIT
# executable. But please consider that the FFI library is compiled-in,
# but NOT loaded by default. It only allocates any memory, if you actually
# make use of it.
#XCFLAGS+= -DLUAJIT_DISABLE_FFI
#
# Features from Lua 5.2 that are unlikely to break existing code are
# enabled by default. Some other features that *might* break some existing
# code (e.g. __pairs or os.execute() return values) can be enabled here.
# Note: this does not provide full compatibility with Lua 5.2 at this time.
XCFLAGS+= -DLUAJIT_ENABLE_LUA52COMPAT
#
# Disable the JIT compiler, i.e. turn LuaJIT into a pure interpreter.
#XCFLAGS+= -DLUAJIT_DISABLE_JIT
#
# Some architectures (e.g. PPC) can use either single-number (1) or
# dual-number (2) mode. Uncomment one of these lines to override the
# default mode. Please see LJ_ARCH_NUMMODE in lj_arch.h for details.
#XCFLAGS+= -DLUAJIT_NUMMODE=1
#XCFLAGS+= -DLUAJIT_NUMMODE=2
#
# Disable LJ_GC64 mode for x64.
#XCFLAGS+= -DLUAJIT_DISABLE_GC64
#
##############################################################################

##############################################################################
############################  DEBUGGING SUPPORT  #############################
##############################################################################
# Enable these options as needed, but make sure you force a full recompile
# with "make clean", followed by "make".
# Note that most of these are NOT suitable for benchmarking or release mode!
#
# Use the system provided memory allocator (realloc) instead of the
# bundled memory allocator. This is slower, but sometimes helpful for
# debugging. This option cannot be enabled on x64 without GC64, since
# realloc usually doesn't return addresses in the right address range.
# OTOH this option is mandatory for Valgrind's memcheck tool on x64 and
# the only way to get useful results from it for all other architectures.
#XCFLAGS+= -DLUAJIT_USE_SYSMALLOC
#
# This define is required to run LuaJIT under Valgrind. The Valgrind
# header files must be installed. You should enable debug information, too.
#XCFLAGS+= -DLUAJIT_USE_VALGRIND
#
# This is the client for the GDB JIT API. GDB 7.0 or higher is required
# to make use of it. See lj_gdbjit.c for details. Enabling this causes
# a non-negligible overhead, even when not running under GDB.
#XCFLAGS+= -DLUAJIT_USE_GDBJIT
#
# Turn on assertions for the Lua/C API to debug problems with lua_* calls.
# This is rather slow -- use only while developing C libraries/embeddings.
#XCFLAGS+= -DLUA_USE_APICHECK
#
# Turn on assertions for the whole LuaJIT VM. This significantly slows down
# everything. Use only if you suspect a problem with LuaJIT itself.
#XCFLAGS+= -DLUA_USE_ASSERT
#
##############################################################################
# You probably don't need to change anything below this line!
##############################################################################

##############################################################################
# Host system detection.
##############################################################################

ifeq (Windows,$(findstring Windows,$(OS))$(MSYSTEM)$(TERM))
  HOST_SYS= Windows
else
  HOST_SYS:= $(shell uname -s)
  ifneq (,$(findstring MINGW,$(HOST_SYS)))
    HOST_SYS= Windows
    HOST_MSYS= mingw
  endif
  ifneq (,$(findstring MSYS,$(HOST_SYS)))
    HOST_SYS= Windows
    HOST_MSYS= mingw
  endif
  ifneq (,$(findstring CYGWIN,$(HOST_SYS)))
    HOST_SYS= Windows
    HOST_MSYS= cygwin
  endif
endif

##############################################################################
# Flags and options for host and target.
##############################################################################

# You can override the following variables at the make command line:
#   CC       HOST_CC       STATIC_CC       DYNAMIC_CC
#   CFLAGS   HOST_CFLAGS   TARGET_CFLAGS
#   LDFLAGS  HOST_LDFLAGS  TARGET_LDFLAGS  TARGET_SHLDFLAGS
#   LIBS     HOST_LIBS     TARGET_LIBS
#   CROSS    HOST_SYS      TARGET_SYS      TARGET_FLAGS
#
# Cross-compilation examples:
#   make HOST_CC="gcc -m32" CROSS=i586-mingw32msvc- TARGET_SYS=Windows
#   make HOST_CC="gcc -m32" CROSS=powerpc-linux-gnu-

ASOPTIONS= $(CCOPT) $(CCWARN) $(XCFLAGS) $(CFLAGS)
CCOPTIONS= $(CCDEBUG) $(ASOPTIONS)
LDOPTIONS= $(CCDEBUG) $(LDFLAGS)

HOST_CC= $(CC)
HOST_RM?= rm -f
# If left blank, minilua is built and used. You can supply an installed
# copy of (plain) Lua 5.1 or 5.2, plus Lua BitOp. E.g. with: HOST_LUA=lua
HOST_LUA=

HOST_XCFLAGS= -I.
HOST_XLDFLAGS=
HOST_XLIBS=
HOST_ACFLAGS= $(CCOPTIONS) $(HOST_XCFLAGS) $(TARGET_ARCH) $(HOST_CFLAGS)
HOST_ALDFLAGS= $(LDOPTIONS) $(HOST_XLDFLAGS) $(HOST_LDFLAGS)
HOST_ALIBS= $(HOST_XLIBS) $(LIBS) $(HOST_LIBS)

STATIC_CC = $(CROSS)$(CC)
DYNAMIC_CC = $(CROSS)$(CC) -fPIC
TARGET_CC= $(STATIC_CC)
TARGET_STCC= $(STATIC_CC)
TARGET_DYNCC= $(DYNAMIC_CC)
TARGET_LD= $(CROSS)$(CC)
TARGET_AR= $(CROSS)ar rcus
TARGET_STRIP= $(CROSS)strip

TARGET_LIBPATH= $(or $(PREFIX),/usr/local)/$(or $(MULTILIB),lib)
TARGET_SONAME= libluajit-$(ABIVER).so.$(MAJVER)
TARGET_DYLIBNAME= libluajit-$(ABIVER).$(MAJVER).dylib
TARGET_DYLIBPATH= $(TARGET_LIBPATH)/$(TARGET_DYLIBNAME)
TARGET_DLLNAME= lua$(NODOTABIVER).dll
TARGET_DLLDOTANAME= libluajit-$(ABIVER).dll.a
TARGET_XSHLDFLAGS= -shared -fPIC -Wl,-soname,$(TARGET_SONAME)
TARGET_DYNXLDOPTS=

TARGET_LFSFLAGS= -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE
TARGET_XCFLAGS= $(TARGET_LFSFLAGS) -U_FORTIFY_SOURCE
TARGET_XLDFLAGS=
TARGET_XLIBS= -lm
TARGET_TCFLAGS= $(CCOPTIONS) $(TARGET_XCFLAGS) $(TARGET_FLAGS) $(TARGET_CFLAGS)
TARGET_ACFLAGS= $(CCOPTIONS) $(TARGET_XCFLAGS) $(TARGET_FLAGS) $(TARGET_CFLAGS)
TARGET_ASFLAGS= $(ASOPTIONS) $(TARGET_XCFLAGS) $(TARGET_FLAGS) $(TARGET_CFLAGS)
TARGET_ALDFLAGS= $(LDOPTIONS) $(TARGET_XLDFLAGS) $(TARGET_FLAGS) $(TARGET_LDFLAGS)
TARGET_ASHLDFLAGS= $(LDOPTIONS) $(TARGET_XSHLDFLAGS) $(TARGET_FLAGS) $(TARGET_SHLDFLAGS)
TARGET_ALIBS= $(TARGET_XLIBS) $(LIBS) $(TARGET_LIBS)

TARGET_TESTARCH:=$(shell $(TARGET_CC) $(TARGET_TCFLAGS) -E lj_arch.h -dM)
ifneq (,$(findstring LJ_TARGET_X64 ,$(TARGET_TESTARCH)))
  TARGET_LJARCH= x64
else
ifneq (,$(findstring LJ_TARGET_X86 ,$(TARGET_TESTARCH)))
  TARGET_LJARCH= x86
else
ifneq (,$(findstring LJ_TARGET_ARM ,$(TARGET_TESTARCH)))
  TARGET_LJARCH= arm
else
ifneq (,$(findstring LJ_TARGET_ARM64 ,$(TARGET_TESTARCH)))
  ifneq (,$(findstring __AARCH64EB__ ,$(TARGET_TESTARCH)))
    TARGET_ARCH= -D__AARCH64EB__=1
  endif
  TARGET_LJARCH= arm64
else
ifneq (,$(findstring LJ_TARGET_PPC ,$(TARGET_TESTARCH)))
  ifneq (,$(findstring LJ_LE 1,$(TARGET_TESTARCH)))
    TARGET_ARCH= -DLJ_ARCH_ENDIAN=LUAJIT_LE
  else
    TARGET_ARCH= -DLJ_ARCH_ENDIAN=LUAJIT_BE
  endif
  TARGET_LJARCH= ppc
else
ifneq (,$(findstring LJ_TARGET_MIPS ,$(TARGET_TESTARCH)))
  ifneq (,$(findstring MIPSEL ,$(TARGET_TESTARCH)))
    TARGET_ARCH= -D__MIPSEL__=1
  endif
  ifneq (,$(findstring LJ_TARGET_MIPS64 ,$(TARGET_TESTARCH)))
    TARGET_LJARCH= mips64
  else
    TARGET_LJARCH= mips
  endif
else
  $(error Unsupported target architecture)
endif
endif
endif
endif
endif
endif

ifneq (,$(findstring LJ_TARGET_PS3 1,$(TARGET_TESTARCH)))
  TARGET_SYS= PS3
  TARGET_ARCH+= -D__CELLOS_LV2__
  TARGET_XCFLAGS+= -DLUAJIT_USE_SYSMALLOC
  TARGET_XLIBS+= -lpthread
endif

TARGET_XCFLAGS+= $(CCOPT_$(TARGET_LJARCH))
TARGET_ARCH+= $(patsubst %,-DLUAJIT_TARGET=LUAJIT_ARCH_%,$(TARGET_LJARCH))

ifneq (,$(PREFIX))
ifneq (/usr/local,$(PREFIX))
  TARGET_XCFLAGS+= -DLUA_ROOT=\"$(PREFIX)\"
  ifneq (/usr,$(PREFIX))
    TARGET_DYNXLDOPTS= -Wl,-rpath,$(TARGET_LIBPATH)
  endif
endif
endif
ifneq (,$(MULTILIB))
  TARGET_XCFLAGS+= -DLUA_MULTILIB=\"$(MULTILIB)\"
endif
ifneq (,$(LMULTILIB))
  TARGET_XCFLAGS+= -DLUA_LMULTILIB=\"$(LMULTILIB)\"
endif
ifneq (,$(INSTALL_LJLIBD))
  TARGET_XCFLAGS+= -DLUA_LJDIR=\"$(INSTALL_LJLIBD)\"
endif

##############################################################################
# Target system detection.
##############################################################################

TARGET_SYS?= $(HOST_SYS)
ifeq (Windows,$(TARGET_SYS))
  TARGET_STRIP+= --strip-unneeded
  TARGET_XSHLDFLAGS= -shared -Wl,--out-implib,$(TARGET_DLLDOTANAME)
  TARGET_DYNXLDOPTS=
else
  TARGET_AR+= 2>/dev/null
ifeq (,$(shell $(TARGET_CC) -o /dev/null -c -x c /dev/null -fno-stack-protector 2>/dev/null || echo 1))

=== libs/pplib/pplib-src/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(pplib
    LANGUAGES C)
set(VERSION 1.0.5)

set(CMAKE_C_STANDARD 99)

add_library(pplib_utils STATIC
    util/utilplat.h
    util/utilcryptdef.h
    util/utildecl.h
    #
    util/utilcrypt.c
    util/utilcrypt.h
    util/utiliof.c
    util/utiliof.h
    util/utillog.c
    util/utillog.h
    util/utilmd5.c
    util/utilmd5.h
    util/utilmem.c
    util/utilmem.h
    #
    util/utilmemheap.c
    util/utilmemheap.h
    util/utilmemheapiof.c
    util/utilmemheapiof.h
    util/utilmeminfo.c
    util/utilmeminfo.h
    #
    util/utilnumber.c
    util/utilnumber.h
    util/utilsha.c
    util/utilsha.h
)

target_include_directories(pplib_utils PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/util>
)

target_link_libraries(pplib_utils
    PUBLIC
        m
        zlib
)

add_library(pplib_filters STATIC
    util/utilbasexx.c
    util/utilbasexx.h
    util/utilflate.c
    util/utilflate.h
    util/utilfpred.c
    util/utilfpred.h
    util/utillzw.c
    util/utillzw.h
)

target_include_directories(pplib_filters PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/util>
)

target_link_libraries(pplib_filters
    PUBLIC
        m
        zlib
)

add_library(pplib
    ppapi.h
    ppconf.h
    pplib.h
    #
    pparray.c
    pparray.h
    ppcrypt.c
    ppcrypt.h
    ppdict.c
    ppdict.h
    ppfilter.h
    ppheap.c
    ppheap.h
    ppload.c
    ppload.h
    ppstream.c
    ppstream.h
    ppxref.c
    ppxref.h
)

target_include_directories(pplib PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/util>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)

target_link_libraries(pplib
    PRIVATE
        pplib_filters
        pplib_utils
)

target_include_directories(pplib
    PRIVATE
        util
)

if (MSVC)
    #set(warning_flags '') # /W4 /WX
else (MSVC)
    set(warning_flags
        -Wall
        -Wextra
        -Wcast-align
        -Wcast-qual
        -Wdeclaration-after-statement
        -Wnested-externs
        -Wno-unknown-pragmas
        -Wpointer-arith
        -Wwrite-strings
    )
    
    foreach(target pplib_utils pplib_filters pplib)
        target_compile_options(${target} PRIVATE ${warning_flags})
    endforeach()
endif (MSVC)

set_target_properties(pplib
    PROPERTIES
        PUBLIC_HEADER "ppapi.h;ppconf.h;pplib.h"
)

add_library(pplib::pplib ALIAS pplib)

install(TARGETS pplib
    EXPORT pplib
    DESTINATION lib
)

enable_testing()

list(APPEND tests pptest1 pptest2 pptest3)

foreach(_test IN LISTS tests)
    add_executable(${_test} ${_test}.c)
    target_link_libraries(${_test} PRIVATE pplib)

    add_test(
        NAME pplib.${_test}
        COMMAND $<TARGET_FILE:${_test}>
    )
endforeach()

=== libs/xpdf/xpdf-src/splash/CMakeLists.txt ===
#========================================================================
#
# splash/CMakeLists.txt
#
# CMake script for the splash library.
#
# Copyright 2015 Glyph & Cog, LLC
#
#========================================================================

if (HAVE_SPLASH)
  include_directories("${PROJECT_SOURCE_DIR}")
  include_directories("${PROJECT_BINARY_DIR}")
  include_directories("${PROJECT_SOURCE_DIR}/goo")
  include_directories("${PROJECT_SOURCE_DIR}/fofi")
  include_directories("${FREETYPE_INCLUDE_DIRS}")

  if (HAVE_DTYPE4_H)
    include_directories("${DTYPE_INCLUDE_DIR}")
    set(DTYPE_SRCS
        SplashDT4Font.cc SplashDT4FontEngine.cc SplashDT4FontFile.cc)
  endif ()

  add_library(splash_objs OBJECT
    Splash.cc
    SplashBitmap.cc
    SplashClip.cc
    SplashFTFont.cc
    SplashFTFontEngine.cc
    SplashFTFontFile.cc
    SplashFont.cc
    SplashFontEngine.cc
    SplashFontFile.cc
    SplashFontFileID.cc
    SplashPath.cc
    SplashPattern.cc
    SplashScreen.cc
    SplashState.cc
    SplashXPath.cc
    SplashXPathScanner.cc
    ${DTYPE_SRCS}
  )
  set_property(TARGET splash_objs
               PROPERTY POSITION_INDEPENDENT_CODE True)

  add_library(splash
    $<TARGET_OBJECTS:splash_objs>
  )
endif ()

=== texk/web2c/cwebdir/examples/Makefile ===
#
# generic Makefile to use when you've got CWEB
# (add it to, or add to it, whatever you like)
#
#======================================================================

CFLAGS = -g
MLIB = -lm
RM = /bin/rm -f
WFILES = extex.w treeprint.w wc.w wmerge.w wordtest.w oemacs.w

#======================================================================

.SUFFIXES: .tex .dvi .w

.w.tex:
	cweave $*

.tex.dvi:	
	tex $<

.w.dvi:
	make $*.tex
	make $*.dvi

.w.c:
	ctangle $*

.w.o:
	make $*.c
	make $*.o

.c.o:
	cc $(CFLAGS) -c $*.c

.w:
	make $*.c
	cc $(CFLAGS) $*.c -o $*

#======================================================================

all: $(WFILES:.w=) excweb

excweb: extex
	ln extex excweb

oemacs: oemacs.c
	cc $(CFLAGS) -I/usr/openwin/include oemacs.c \
             -o oemacs -lxview -lolgx -lX11

doc: $(WFILES:.w=.dvi)

clean:
	$(RM) *~ \#~ .\#* *.o *.log *.dvi *.toc core a.out

clobber: clean
	$(RM) $(WFILES:.w=) $(WFILES:.w=.c) $(WFILES:.w=.tex)

=== texk/web2c/doc/luatex/Makefile ===
# This Makefile is public domain. Originally written by Karl Berry, 2025.
# install luatex manual from Build to Master in TeX Live.

Master = ../../../../../../Master
dest = $(Master)/texmf-dist/doc/luatex/base/
lua_source_dir = ../../luatexdir

INSTALL_DATA = cp -p

install:
	@test -d $(dest) \
	|| { ls $(Master) echo "dest not directory: $(dest)" >&2; ls $(dest); exit 1; }
	$(INSTALL_DATA) *.tex $(dest)/
	$(INSTALL_DATA) *.pdf $(dest)/
	$(INSTALL_DATA) -r graphics/ $(dest)/
	$(INSTALL_DATA) $(lua_source_dir)/ChangeLog $(dest)/
	$(INSTALL_DATA) $(lua_source_dir)/NEWS $(dest)/

=== texk/web2c/hitexdir/doc/Makefile ===
# $Id: Makefile 62855 2022-03-21 15:11:58Z karl $
# Standalone Makefile for hitex/doc. Public domain.
# This is not run as part of the build, just a convenience used by hand
# from the Build/source/... directory.

INSTALL_DATA = cp -pfv

texmf_dist = ../../../../../../Master/texmf-dist
hitex_makeindex_dir = $(texmf_dist)/makeindex/hitex
hitex_doc_dir = $(texmf_dist)/doc/hitex/base
#
install:
	$(INSTALL_DATA) hint.ist $(hitex_makeindex_dir)
	for f in hiformat.hnt hiformat.pdf hintmac.tex \
	         hitexman.hnt hitexman.pdf hitexman.tex; do \
	  $(INSTALL_DATA) $$f $(hitex_doc_dir)/ || exit 1; done
	cd $(hitex_doc_dir) && /bin/pwd && svn status

=== debian/changelog ===
texlive-bin (2025.20250727.75242+ds-5~hurd.1) unreleased; urgency=medium

  [ Pino Toscano ]
  * Import patch 0001-consider-Hurd-as-a-POSIX-system.patch from src:luajit as
    luajit-hurd.diff to support Hurd in the embedded luajit copy.
  * Use DEB_HOST_ARCH rather than DEB_HOST_ARCH_CPU to use the embedded zziplib
    copy on any i386 architecture, not only on Linux, as the problem applies
    regardless of the OS.
  * Enable the luajit support also on hurd-amd64.
  * Add a workaround for missing automake dependencies in single job builds.

 -- Debian TeX Task Force <debian-tex-maint@lists.debian.org>  Sun, 17 Aug 2025 09:38:50 +0200

=== debian/control ===
Source: texlive-bin
Section: tex
Priority: optional
Maintainer: Debian TeX Task Force <debian-tex-maint@lists.debian.org>
Uploaders: Norbert Preining <norbert@preining.info>,
	Hilmar Preuße <hille42@debian.org>
Build-Depends:
  debhelper-compat (= 13)
Build-Depends-Arch:
  autoconf,
  automake,
  bison,
  flex,
  libbrotli-dev,
  libcairo2-dev,
  libfontconfig-dev,
  libfreetype-dev,
  libgmp-dev,
  libgraphite2-dev,
  libharfbuzz-dev (>= 2.4),
  libicu-dev,
  libmpfi-dev (>= 1.5.4),
  libmpfr-dev,
  libpaper-dev,
  libpotrace-dev,
  libpixman-1-dev,
  libpng-dev,
  libteckit-dev,
  libtool,
  libxaw7-dev (>= 2:1.0.16),
  libxi-dev,
  libzzip-dev,
  m4,
  texlive-binaries <cross>,
  zlib1g-dev | libz-dev
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://www.tug.org/texlive/
Vcs-Git: https://github.com/debian-tex/texlive-bin.git
Vcs-Browser: https://github.com/debian-tex/texlive-bin

Package: texlive-binaries
Architecture: any
Multi-Arch: foreign
Depends: libptexenc1 (>= ${source:Version}),
  libptexenc1 (<< ${source:Version}.1~),
  libkpathsea6 (>= ${source:Version}),
  libkpathsea6 (<< ${source:Version}.1~),
  libsynctex2 (>= ${source:Version}),
  libsynctex2 (<< ${source:Version}.1~),
  libtexlua53-5 (>= ${source:Version}),
  libtexlua53-5 (<< ${source:Version}.1~),
  t1utils, tex-common, perl:any,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: texlive-base, dvisvgm
Suggests: texlive-binaries-sse2 [amd64 armel armhf arm64 hurd-amd64 hurd-i386 i386 powerpc], hintview
Replaces: ptex-bin, mendexk, jmpost, luatex (<< 2014), gregorio (<= 2.3-1),
    texlive-extra-utils (<< 2020.20200329), texlive-luatex (<< 2020.20200329)
Conflicts: mendexk, makejvf, jmpost
Breaks: texlive-base (<< 2021), luatex (<< 2014), gregorio (<= 2.3-1),
    texlive-extra-utils (<< 2020.20200329), texlive-luatex (<< 2020.20200329),
    context (<= 2021.03.05.20230120+dfsg-1), texlive-formats-extra (<< 2023.20230613)
Provides: texlive-base-bin, makejvf, mendexk, jmpost, luatex
Description: Binaries for TeX Live
 This package contains all the binaries of TeX Live packages.
 .
 Note that this package alone has hardly any functionality.  Rather,
 choose the texlive-* packages you want to use, e.g.
 texlive-latex-recommended or context

Package: texlive-binaries-sse2
Architecture: amd64 armel armhf arm64 hurd-amd64 hurd-i386 i386 powerpc
Multi-Arch: foreign
Depends: libptexenc1 (>= ${source:Version}),
  libptexenc1 (<< ${source:Version}.1~),
  libkpathsea6 (>= ${source:Version}),
  libkpathsea6 (<< ${source:Version}.1~),
  libsynctex2 (>= ${source:Version}),
  libsynctex2 (<< ${source:Version}.1~),
  libtexlua53-5 (>= ${source:Version}),
  libtexlua53-5 (<< ${source:Version}.1~),
  libtexluajit2 (>= ${source:Version}) [amd64 armel armhf arm64 hurd-amd64 hurd-i386 i386 powerpc],
  libtexluajit2 (<< ${source:Version}.1~) [amd64 armel armhf arm64 hurd-amd64 hurd-i386 i386 powerpc],
  sse2-support [i386],
  t1utils, tex-common, perl:any,
  ${shlibs:Depends}, ${misc:Depends}, texlive-binaries
Replaces: texlive-binaries (<= 2023.20230311.66589-4)
Breaks: texlive-binaries (<= 2023.20230311.66589-4)
Description: Binaries for TeX Live (the JIT part)
 This package contains all the binaries of TeX Live packages.
 .
 Note that this package alone has hardly any functionality.  Rather,
 choose the texlive-* packages you want to use, e.g.
 texlive-latex-recommended or context
 .
 This package contains the luajit binaries, which run only on sse2
 capable CPU's.

Package: libkpathsea6
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: TeX Live: path search library for TeX (runtime part)
 This package contains the runtime part of the Kpathsea[rch] library,
 which implements generic path searching, configuration, and
 TeX-specific file searching.

Package: libkpathsea-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libkpathsea6 (= ${binary:Version})
Description: TeX Live: path search library for TeX (development part)
 This package contains the static library and header files for the
 Kpathsea[rch] library, which implements generic path searching,
 configuration, and TeX-specific file searching.

Package: libptexenc1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: TeX Live: pTeX encoding library
 library for encoding support in pTeX, a Japanese TeX engine.

Package: libptexenc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libptexenc1 (= ${binary:Version})
Description: TeX Live: ptex encoding library (development part)
 This package contains the static library and header files for the
 ptexenc library, a library for encoding support in pTeX, a Japanese
 TeX engine.

Package: libsynctex2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: TeX Live: SyncTeX parser library
 Library for SyncTeX parsing support.

Package: libsynctex-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libsynctex2 (= ${binary:Version})
Description: TeX Live: SyncTeX parser library (development part)
 This package contains the static library and header files for the SyncTex
 parser library.

Package: libtexlua53
Section: oldlibs
Architecture: all
Depends: libtexlua53-5, ${misc:Depends}
Description: transitional package (lib)
 This is a transitional (library) package. It can safely be removed.

Package: libtexlua53-5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Replaces: libtexlua53 (<< 2022.20220321.62855-2~)
Breaks: libtexlua53 (<< 2022.20220321.62855-2~)
Description: TeX Live: Lua 5.3, modified for use with LuaTeX
 The Lua 5.3 library as used within LuaTeX.

Package: libtexlua53-dev
Section: oldlibs
Architecture: all
Depends: libtexlua-dev, ${misc:Depends}
Description: transitional package (dev)
 This is a transitional (development) package. It can safely be removed.

Package: libtexlua-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libtexlua53-5 (= ${binary:Version})
Replaces: libtexlua53-dev (<< 2022.20220321.62855-2~)
Breaks: libtexlua53-dev (<< 2022.20220321.62855-2~)
Description: TeX Live: Lua 5.3, modified for use with LuaTeX (development part)
 This package contains the static library and header files for the texlua
 library.

Package: libtexluajit2
Section: libs
Architecture: amd64 armel armhf arm64 hurd-amd64 hurd-i386 i386 powerpc
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: TeX Live: LuaJIT, modified for use with LuaJITTeX
 The LuaJIT library as used within LuaJITTeX.

Package: libtexluajit-dev
Section: libdevel
Architecture: amd64 armel armhf arm64 hurd-amd64 hurd-i386 i386 powerpc
Multi-Arch: same
Depends: ${misc:Depends}, libtexluajit2 (= ${binary:Version})
Description: TeX Live: LuaJIT, modified for use with LuaJITTeX (development part)
 This package contains the static library and header files for the texluajit
 library.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for texlive-bin

export SHELL=/bin/bash
export CONFIG_SHELL=/bin/bash

export DEBIANTMP=debian/tmp

# this ships out the test logs when a test failed, set it in any case
export VERBOSE=1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#
# the configure code already checks a lot, but it does not catch
# all cases. We have now two ways to test for where to build.
# One by disabling on the other platforms, one by whitelisting
# and building only on some platforms.
LUAJIT_GOOD_ARCHS := amd64 armel armhf arm64 hurd-amd64 hurd-i386 i386 powerpc

# In case one wants to build with old automake (<< 1.13.1), the following
# variable has to be set. By default the debian/control requires high
# enough versions of automake and friends
#export AM_V_P=false

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH), alpha)
  export LDFLAGS = -Wl,--no-relax
endif

#
#
# architectures where icu related programs (xetex) have problems
# and core dump etc. Possible fix, but sub-optimal because slowing down
# programs
# TODO should be checked whether this still happens!
BROKEN_ICU_ARCHS := sparc64
ifneq (,$(findstring $(DEB_HOST_ARCH), $(BROKEN_ICU_ARCHS)))
  export CFLAGS += -DU_IS_BIG_ENDIAN=0
  export CXXFLAGS += -DU_IS_BIG_ENDIAN=0
else
endif


# for whitelisting good archs
ifeq (,$(filter $(DEB_HOST_ARCH), $(LUAJIT_GOOD_ARCHS)))
  # it is not in the list of good archs -> disable luajittex
  BUILDLUAJITTEX=--disable-luajittex --disable-mfluajit --disable-luajithbtex
  WITHLUAJIT=no
else
  # not necessary, but for completeness
  BUILDLUAJITTEX=--enable-luajittex --enable-mfluajit --enable-luajithbtex
  WITHLUAJIT=yes
endif

ZZIPLIB=--with-system-zziplib

ifeq ($(DEB_HOST_ARCH_CPU), i386)
  # Not use system zziplib on i386 arches.
  ZZIPLIB=--without-system-zziplib
endif

#
# it seems that ARM metafont segfaults due to a problem with armhf's malloc
# see Debian bug #678604
# Building in arm mode helps
#
ifeq ($(DEB_HOST_ARCH), armhf)
  export CFLAGS += -marm
endif

# warning: if the --with autoreconf is removed then
# the patch debian/patches/debian-no-linked-scripts
# must be adapted to also patch the Makefile.in!

# Workaround for incompatibility to GCC 15.
# Mostly lua[hb][jit]text, pdftex & ps2pk are not fixed yet.
export CFLAGS += -std=gnu17

%:
	dh $@ --builddirectory Work --max-parallel=8

#
# we use TL provided reautoconf script as it has some built-in magic
override_dh_autoreconf-arch:
	dh_autoreconf ./reautoconf

override_dh_autoreconf-indep:
	# Nothing to do here

# this was used before, but I am not sure whether the -as-needed is necessary
#	dh_autoreconf --as-needed

#
# poppler is used two times in TeX Live:
# once for pdftex/xetex
# once for luatex -> obsolete, luatex uses pplib
# - the pdftex/xetex version is controlled via --with-system-xpdf
# - the luatex version is controlled via --with-system-poppler
#
# Status as of 20180118
# poppler in Debian is NOT enough for current, so we use the shipped
# libraries for both.
#	--with-system-poppler			\
#	--with-system-xpdf			\
#
# Status as of 20230913
# TL upstream stopped using poppler to get pdf support in pdftex
# and pdftosrc. Instead they use the shipped xpdf "library". The
# configure option "--with-system-xpdf" does not do anything.
# https://tug.org/pipermail/tex-live/2023-September/049457.html ff.

# disable-largefile seems to break omegafonts, as they core dump
# leave it as is for now and see what else pops up
#	--disable-largefile			\

override_dh_auto_configure-arch:
	# we have to make sure that the mendex test case that is added
	# by a patch is executable, same for pdftexdir - stupid dpkg-source
	chmod 0755 texk/mendexk/tests/mendex.test
	chmod 0755 texk/web2c/pdftexdir/expanded.test
	# make sure that the lacheck test script is executable
	# this is only necessary since quilt/dpkg does not support
	# permissions
	chmod ugo+x utils/lacheck/test-def.test
	chmod ugo+x libs/zziplib/zziplib.test
	
	# run out configure script
	dh_auto_configure -- -C --prefix=/usr	\
	--datarootdir=/usr/share/texlive	\
	--disable-native-texlive-build		\
	--disable-missing			\
	--disable-linked-scripts		\
	--with-banner-add=/Debian		\
	--enable-shared				\
	--with-system-zlib			\
	--with-system-zzlib			\
	--with-system-potrace			\
	--with-system-graphite2			\
	--with-system-harfbuzz 			\
	--with-system-libgs			\
	--with-system-pixman			\
	--with-system-libpaper			\
	$(ZZIPLIB)			\
	--with-system-icu			\
	--with-system-gmp			\
	--with-system-mpfi			\
	--with-system-mpfr			\
	--with-system-freetype2			\
	--with-freetype2-include=/usr/include/freetype2 \
	--with-system-libpng			\
	--with-system-gd			\
	--with-system-cairo 			\
	--with-system-teckit			\
	--with-x				\
	--with-mf-x-toolkit			\
	--with-xdvi-x-toolkit=xaw		\
	$(BUILDLUAJITTEX)			\
	--disable-lcdf-typetools		\
	--disable-biber				\
	--disable-dvipng			\
	--disable-ps2eps			\
	--disable-psutils			\
	--disable-t1utils			\
	--disable-cjkutils			\
	--disable-chktex			\
	--disable-dvidvi			\
	--disable-lacheck			\
	--disable-texdoctk			\
	--disable-ttf2pk			\
	--disable-dvisvgm			\
	--enable-ttf2pk2			\
	--enable-ipc				

	# HACK: manually create the detex-src subdirectory inside the build
	# directory to ensure it exists; the situation is the following:
	# - texk/detex/Makefile.am has a rule to generate detex-src/detex.h
	#   from detex-src/detex.l using lex (wrapped in build-aux/ylwrap)
	# - ylwrap does not create any missing subdirectory for the output file
	# - automake (currently 1.17) generate a rule to create the needed
	#   subdirectory, however it is only added as dependency for the
	#   detex-src/detex.o object file (build from detex-src/detex.c, which
	#   includes the generated detex-src/detex.h); this rule is also
	#   written in the Makefile after the rule to invoke ylwrap
	# - GNU make starting from 4.4 remakes rules in the same order they
	#   were processed, rather the opposite as in previous versions
	# When building with a single build job, the rule to generate
	# detex-src/detex.h is processed before the rule to create the output
	# subdirectory; thus in a builddir!=srcdir build ylwrap fails as:
	# ../../../texk/detex/../../build-aux/ylwrap: line 204: ../detex-src/detex.c: No such file or directory
	# While this feels like a bug in automake, work around it for now.
	mkdir -p $(CURDIR)/Work/texk/detex/detex-src/

override_dh_auto_configure-indep:
	# Nothing to do here

override_dh_auto_install-arch:
	dh_auto_install -- DESTDIR=$(CURDIR)/$(DEBIANTMP)

override_dh_auto_install-indep:
	# Nothing to do here

override_dh_install-arch:
	# remove .la files which we do not install, so that dh_install
	# can work with --fail-missing
	rm -f $(DEBIANTMP)/usr/lib/*.la $(DEBIANTMP)/usr/lib/*/*.la
	# mv c-auto.h into arch-dependent include path
	mkdir -p $(DEBIANTMP)/usr/include/$(DEB_HOST_MULTIARCH)/kpathsea
	mv $(DEBIANTMP)/usr/include/kpathsea/c-auto.h \
		$(DEBIANTMP)/usr/include/$(DEB_HOST_MULTIARCH)/kpathsea/
	dh_install --sourcedir=$(CURDIR)/$(DEBIANTMP)
	dh_missing --sourcedir=$(CURDIR)/$(DEBIANTMP) --fail-missing

execute_after_dh_install-arch:
	# replace xdvi wrapper shell script with perl variant to
	# allow for opening of gz etc files
	rm debian/texlive-binaries/usr/bin/xdvi
	install -m 0755 debian/xdvi-pl debian/texlive-binaries/usr/bin/xdvi
	# remove texlive directories, they should not be shipped here
	rm -rf debian/texlive-binaries/usr/share/texlive
	# remove wrongly added info/dir.gz
	rm -f debian/texlive-binaries/usr/share/info/dir*
	# remove tlbuild info document, not needed
	rm debian/texlive-binaries/usr/share/info/tlbuild.info*
	# remove various man pages
	for i in latex latex-dev pdflatex pdflatex-dev lamed lualatex-dev dvilualatex-dev \
		dviluatex platex-dev uplatex-dev xelatex-dev amstex \
		eptex euptex ptex pbibtex ppltotf ptftopl upbibtex uppltotf uptex uptftopl \
		texprof texprofile ; do \
